#!/usr/bin/env python

from sss.server import SSSSelectEventReceiver
from daemonize import daemonize
from getopt import getopt,GetoptError
from sys import argv,exit
from xml.dom.minidom import Document

class event_sync:
    def __init__(self):
        self.dispatch={'event':self.HandleEvent}
        self.response=Document().createElement("event-ok")

    def HandleEvent(self,xe,(peer,port)):
        print xe.toxml()
        return self.response
            
if __name__ == "__main__":
    try:
        (options,args) = getopt(argv[1:],"m:d:",["maxcount=","daemon="])
    except GetoptError, msg:
        print msg
        print "Usage: event_sync.py (-m | --maxcount=)maxcount [(-d |--daemon=)pidfile]"
        exit(1)
    pidfile = None
    maxcount = 10
    for opt in options:
        if opt[0] in ['-m','--maxcount']:
            maxcount = int(opt[1])
        if opt[0] in ['-d','--daemon']:
            pidfile = opt[1]
    if pidfile:
        daemonize(pidfile)
    server=SSSSelectEventReceiver('*','*','*','multi',event_sync())
    server.ServeN(maxcount)
