#!/usr/bin/env python

from exceptions import ValueError
from re import compile
from string import join
from sys import argv,exit
from threading import Thread, Lock
from time import gmtime, mktime, strftime, time
from xml.dom.minidom import Document

from sss.ssslib import comm_lib

getopt=compile("-t (\d+) -n (\d+)") 
try:
    m=getopt.match(join(argv[1:],' '))
    numthreads=int(m.group(1))
    nummsgs=int(m.group(2))
except (ValueError,AttributeError):
    print "usage:"
    print "sdbench.py -t [number] -n [number]"
    exit(1)

comm=comm_lib()
comm_lock=Lock()

def sdquery(num):
    for x in xrange(num):
        comm_lock.acquire()
        h=comm.ClientInit('service-directory')
        comm_lock.release()
        comm_lock.acquire()
        comm.ClientClose(h)
        comm_lock.release()

threads=map(lambda x:Thread(target=sdquery, args=[nummsgs]),xrange(numthreads))
start=gmtime()
stime=time()

map(lambda x:x.start(),threads)
#print "Starting at %s"%(strftime("%c",start))
map(lambda x:x.join(),threads)

end=gmtime()
etime=time()
#print "Finished at %s"%(strftime("%c",end))
print "Total Time: %s seconds"%(etime-stime)
