#!/usr/bin/env python

from sys import exit,path
from time import sleep
import xml.dom.minidom 

path.append("../lib")
from sss.ssslib import comm_lib
def main():
    create='''<?xml version="1.0" encoding="UTF-8" ?>
    
<PMRequests>
    <create-process-group reqid="1" process-group-id="%s" totalprocs="%s" search-path="%s" cwd="%s" host="topaz" userid="%s" exec="%s">
       <args>
         <arg value="joe1"/>
         <arg value="joe2"/>
       </args>
       <io stream="stdout">
         <tty/>
         <file path="/tmp/mpirun_out" mode="a"/>
       </io>
       <io stream="stderr">
         <tty/>
       </io>
    </create-process-group>
</PMRequests>

'''
    action='''<?xml version="1.0" encoding="UTF-8" ?>

<PMRequests>
    <process-group-action reqid="1" pgid="%s" signal="%s"/>
</PMRequests>

'''

    jobqueue={1:{'totalprocs':4,
                 'search-path':"/home/desai/pkgs/mpd/bin:/usr/local/bin:/home/alusk/bin/bin",
                 "cwd":"/tmp",'userid':'desai','exec':'cpi'},
              4:{'totalprocs':1,
                 'search-path':"/home/desai/pkgs/mpd/bin:/usr/local/bin:/home/alusk/bin/bin",
                 "cwd":"/tmp",'userid':'desai','exec':'/home/desai/infloop'},
              7:{'totalprocs':7,
                 'search-path':"/home/desai/pkgs/mpd/bin:/usr/local/bin:/home/alusk/bin/bin",
                 "cwd":"/tmp",'userid':'desai','exec':'cpi'}}
    
    print jobqueue.keys()
    comm=comm_lib()
    handle = comm.ClientInit('process-manager')
    # Now we run the queue
    while(len(jobqueue.keys()) > 0):
        pgid=min(jobqueue.keys())
        print "submitting process group %s"%(pgid)
        job=jobqueue[pgid]
        str = create%(pgid,job['totalprocs'],
                                 job['search-path'],job['cwd'],
                                 job['userid'],job['exec'])
                         
        print "sending :%s:"%str
        comm.SendMessage(handle,str)
        response=comm.RecvMessage(handle)
        doc=xml.dom.minidom.parseString(response)

        [response]=doc.getElementsByTagName("PMStatus")
        print doc.toxml()
        if response.getAttribute('outcome') == 'success':
            print "process group %s submitted"%(pgid)
            if pgid == 4:
                sleep(10)
                print "suspending process group 4"
                comm.SendMessage(handle,action%(4,'SIGTSTP'))
                response=comm.RecvMessage(handle)
                sleep(10)
                print "resuming process group 4"
                comm.SendMessage(handle,action%(4,'SIGCONT'))
                response=comm.RecvMessage(handle)
                sleep(10)
                print "killing process group 4"
                comm.SendMessage(handle,action%(4,'SIGTERM'))
                response=comm.RecvMessage(handle)
            del jobqueue[pgid]
        else:
            print "process group not successfully submitted"
        sleep(4)
    comm.ClientClose(handle)

if __name__ == '__main__':
    main()
      
